#!/usr/bin/python3

# ## {R2D2919B742E} ##
# ###########################################################################
# What if magic existed?
# What if a place existed where your every thought and dream come to life.
# There is only one catch: it has to be written down.
# Such a place exists, it is called programming.
#    - Scott Taylor Reph, RightThumb.com
# ###########################################################################
# ## {C3P0D40fAe8B} ##
##################################################
import os, sys, time
##################################################
import _rightThumb._construct as __
appDBA = __.clearFocus( __name__, __file__ )
__.appReg = appDBA
def focus( parentApp='', childApp='', reg=True ):
    global appDBA
    f = __.appName( appDBA, parentApp, childApp )
    if reg:
        __.appReg = f
    return f
__.registeredApps.append( focus() )
import _rightThumb._base3 as _
_.load()
##################################################
import _rightThumb._vars as _v
import _rightThumb._string as _str
##################################################

def appSwitches():
    _.switches.register( 'Files', '-f,-file,-files','file.txt', description='Files', isRequired=True )
    _.switches.register( 'Save', '-save' )
    pass

_.autoBackupData = __.setting('receipt-log')
__.releaseAcquiredData = __.setting('receipt-file')
__.myFileLocations_SKIP_VALIDATION = False
__.isRequired_Pipe = False
__.isRequired_Pipe_or_File = False
__.pre_error = False
__.switch_raw = []
# __.switch_raw = [ 'Delim' ]
# __.isRequired_or_List = ['Pipe','Files','Plus']
# __.setting( 'app-switches-raw', [ 'Delim' ] )


_.appInfo[focus()] = {
    'file': 'vps-hoth-7i0ZA-7GzGHN-invoices-cleanup.py',
    'liveAppName': __.thisApp( __file__ ),
     'description': 'cleanup invoices project',
    'categories': [
                        'invoices',
                        'clean',
                ],
    'usage': [
                        # 'epy another',
                        # 'e nmap',
                        # '',
    ],
    'relatedapps': [
                        # 'p another -file file.txt',
                        # '',
    ],
    'prerequisite': [
                        # 'p another -file file.txt',
                        # '',
    ],
    'examples': [

                        _.hp('p vps-hoth-7i0ZA-7GzGHN-invoices-cleanup -f invoice2go_20390768_invoice_1643403092055.csv -save invoices.json '),
                        '',
    ],
    'columns': [
                       # { 'name': 'name', 'abbreviation': 'n' },
                       # { 'name': '{1}', 'abbreviation': '{0}', 'sort': '{2}' },
    ],
    'aliases': [
                       # 'this',
                       # 'app',
    ],
    'notes': [
                       # {},
    ],
}

_.appData[focus()] = {
        'start': __.startTime,
        'uuid': '',
        'audit': [],
        'pipe': False,
        'data': {
                    'field': {'sent': [], 'received': [] }, # { 'label': '', 'context': [],  }
                    'table': {'sent': [], 'received': [] }, 
        },
    }



def registerSwitches( argvProcessForce=False ):
    global appDBA
    if not __.appReg == appDBA and appDBA in __.appReg:

        if not __name__ == '__main__':
            _.argvProcess = argvProcessForce
        else:
            _.argvProcess = True

        _.load()
        _.appInfo[__.appReg] = _.appInfo[appDBA]
        _.appData[__.appReg] = _.appData[appDBA]
    __.constructRegistration( _.appInfo[__.appReg]['file'],__.appReg )
    appSwitches()

    _.myFileLocation_Print = False
    _.switches.trigger( 'Files', _.myFileLocations, vs=True )
    _.switches.trigger( 'Folder', _.myFolderLocations )
    _.switches.trigger( 'URL', _.urlTrigger )
    _.switches.trigger( 'Ago', _.timeAgo )
    _.switches.trigger( 'Duration', _.timeFuture )
    
    _.defaultScriptTriggers()
    _.switches.process()


if not __name__ == '__main__':
    _.argvProcess = False
else:
    _.argvProcess = True

registerSwitches()


def fieldSet( switchName, switchField, switchValue, theFocus=False ):
    if not type( theFocus ) == bool:
        theFocus = theFocus
    _.switches.fieldSet( switchName, switchField, switchValue, theFocus )


if __name__ == '__main__':
    if not sys.stdin.isatty():
        _.setPipeData( sys.stdin.readlines(), __.appReg, clean=True )


_.postLoad( __file__ )

########################################################################################
# START



def action():
    csv = _.csv( _.switches.values('Files')[0] )
    records = _.tables.returnSorted( 'data', 'd.DocumentDate', csv )
    for i,rec in enumerate(records):
        records[i]['epoch'] = _.autoDate(rec['DocumentDate'])
        records[i]['recID'] = i
        for sub in 'Payments,Items'.split(','):
            code = rec[sub]
            code = code.replace(';','\n')
            quotes = {}
            a=0
            for ii, pa in enumerate( _.find_all(code,'"') ):
                
                if not a:
                    last=pa
                    quotes[pa]={}
                    a=1
                else:
                    a=0
                    quotes[last]=pa
            for k in quotes:
                code = code.replace(   code[k:quotes[k]+1],   code[k:quotes[k]+1].replace('\n','\\n')   )
            # items = _.csvTXT( code )
            _.saveText( code, '~temp.csv' )
            items = _.csv('~temp.csv')
            for iii,child in enumerate(items):
                dic = {}
                for kik in child:
                    dic[kik] = child[kik].replace('\\n','\n')
                items[iii] = dic
            records[i][sub] = items
        # _.pv( rec )
        # _.pr(rec)
    pass
    os.remove('~temp.csv')
    if _.switches.isActive('Save'):
        _.saveTable2(records,_.switches.values('Save')[0])



########################################################################################
if __name__ == '__main__':
    action()
    __.isExit()





